# Prints a SAT program in CNF for the nxn queens problem. Each clause
# is a list of ints.

def pair2int(n,r,c):
    return n*(r-1)+c

def attackRestOfRowLeft(n,r,c): # returns a list of clauses
    lengthOfRest = n-c
    return [[-pair2int(n,r,c), -pair2int(n,r,c+k)] for k in range(1,lengthOfRest+1)]

def attackRestOfColumnDown(n,r,c): # returns a list of clauses
    lengthOfRest = n-r
    return [[-pair2int(n,r,c), -pair2int(n,r+k,c)] for k in range(1,lengthOfRest+1)]

def attackRestOfDiagonalRightDown(n,r,c): # returns a list of clauses
    lengthOfRest = min(n-r,n-c)
    return [[-pair2int(n,r,c), -pair2int(n,r+k,c+k)] for k in range(1,lengthOfRest+1)]

def attackRestOfDiagonalLeftDown(n,r,c): # returns a list of clauses
    lengthOfRest = min(n-r,c-1)
    return [[-pair2int(n,r,c), -pair2int(n,r+k,c-k)] for k in range(1,lengthOfRest+1)]

def rowNotEmpty(n,r): # returns a single clause
    return [pair2int(n,r,c) for c in range(1,n+1)]

n = int(input("Please input n:\n"))
clauses = []
for r in range(1,n+1):
    for c in range(1,n+1):
        clauses.extend(attackRestOfRowLeft(n,r,c))
        clauses.extend(attackRestOfColumnDown(n,r,c))
        clauses.extend(attackRestOfDiagonalRightDown (n,r,c))
        clauses.extend(attackRestOfDiagonalLeftDown (n,r,c))
for r in range(1,n+1):
    clauses.append(rowNotEmpty(n,r))

print("p cnf", n**2, len(clauses))        
for clause in clauses:
    clause.append(0)
    print(*clause) # The use of * during a call unpacks a list, i.e.,
                   # its elements become arguments of the call to
                   # print (exploiting that print can work with any
                   # number of arguments).
