# Prints a SAT program in CNF for the 3x3 towers problem. Here in a
# second version which first collects the clauses and then formats the
# output in the end (which is arguably cleaner, as it separates the
# construction and the formatting phases). It also switches to list
# comprehension instead for loops, just for variation. Each clause is
# a list of ints.

def pair2int(r,c):
    return 3*(r-1)+c

def attackRestOfRowLeft(r,c): # returns a list of clauses
    lengthOfRest = 3-c
    return [[-pair2int(r,c), -pair2int(r,c+k)] for k in range(1,lengthOfRest+1)]

def attackRestOfColumnDown(r,c): # returns a list of clauses
    lengthOfRest = 3-r
    return [[-pair2int(r,c), -pair2int(r+k,c)] for k in range(1,lengthOfRest+1)]

def rowNotEmpty(r): # returns a single clause
    return [pair2int(r,c) for c in range(1,4)]

clauses = []
for r in range(1,4):
    for c in range(1,4):
        clauses.extend(attackRestOfRowLeft(r,c))
        clauses.extend(attackRestOfColumnDown(r,c))
for r in range(1,4):
    clauses.append(rowNotEmpty(r))

print("p cnf", 9, len(clauses))        
for clause in clauses:
    clause.append(0)
    print(*clause) # The use of * during a call unpacks a list, i.e.,
                   # its elements become arguments of the call to
                   # print (exploiting that print can work with any
                   # number of arguments).
